// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2020 Aman Goel
// SPDX-FileCopyrightText: 2022 The SV-Benchmarks Community
//
// SPDX-License-Identifier: GPL-3.0-or-later

// This C program is converted from Btor2 by Btor2C version sha1:a0fa249
//   with arguments: { architecture=64, lazy_modulo=true, use_memmove=false, unroll_inner_loops=false, shortest_type=true, diff_type=true, decimal_constant=true, zero_init=false, sra_extend_sign=true }
// Comments from the original Btor2 file:
// ; source: https://github.com/aman-goel/avr/tree/92362931700b66684418a991d018c9fbdbebc06f/tests
// ; BTOR description generated by Yosys 0.9+431 (git sha1 4a3b5437, clang 4.0.1-6 -fPIC -Os) for module main.
extern unsigned char __VERIFIER_nondet_uchar();
extern unsigned short __VERIFIER_nondet_ushort();
extern unsigned int __VERIFIER_nondet_uint();
extern unsigned long __VERIFIER_nondet_ulong();
extern void abort(void);
extern void __assert_fail(const char *, const char *, unsigned int, const char *);
void reach_error() { __assert_fail("0", "vcegar_QF_BV_itc99_b13_p14.c", 0, "reach_error"); }
void __VERIFIER_assert(int cond) { if (!(cond)) { ERROR: { reach_error(); abort(); } } }
void assume_abort_if_not(int cond) { if (!cond) { abort(); } }
int main() {
  // Defining sorts ...
  typedef unsigned char SORT_1;  // BV with 1 bits
  const SORT_1 mask_SORT_1 = (SORT_1)-1 >> (sizeof(SORT_1) * 8 - 1);
  const SORT_1 msb_SORT_1 = (SORT_1)1 << (1 - 1);
  typedef unsigned char SORT_3;  // BV with 8 bits
  const SORT_3 mask_SORT_3 = (SORT_3)-1 >> (sizeof(SORT_3) * 8 - 8);
  const SORT_3 msb_SORT_3 = (SORT_3)1 << (8 - 1);
  typedef unsigned int SORT_10;  // BV with 32 bits
  const SORT_10 mask_SORT_10 = (SORT_10)-1 >> (sizeof(SORT_10) * 8 - 32);
  const SORT_10 msb_SORT_10 = (SORT_10)1 << (32 - 1);
  typedef unsigned char SORT_32;  // BV with 4 bits
  const SORT_32 mask_SORT_32 = (SORT_32)-1 >> (sizeof(SORT_32) * 8 - 4);
  const SORT_32 msb_SORT_32 = (SORT_32)1 << (4 - 1);
  typedef unsigned short SORT_70;  // BV with 10 bits
  const SORT_70 mask_SORT_70 = (SORT_70)-1 >> (sizeof(SORT_70) * 8 - 10);
  const SORT_70 msb_SORT_70 = (SORT_70)1 << (10 - 1);
  // Initializing constants ...
  const SORT_1 var_7 = 0;
  const SORT_10 var_12 = 0;
  const SORT_1 var_22 = 1;
  const SORT_70 var_71 = 0;
  const SORT_10 var_95 = 104;
  const SORT_10 var_143 = 1;
  // Collecting input declarations ...
  SORT_1 input_2;
  SORT_3 input_4;
  SORT_1 input_5;
  SORT_1 input_6;
  SORT_1 input_30;
  SORT_32 input_33;
  SORT_1 input_35;
  SORT_32 input_37;
  SORT_1 input_39;
  SORT_1 input_41;
  SORT_1 input_47;
  SORT_1 input_49;
  SORT_1 input_51;
  SORT_3 input_55;
  SORT_1 input_58;
  SORT_1 input_66;
  SORT_1 input_75;
  SORT_1 input_77;
  SORT_1 input_89;
  SORT_1 input_90;
  SORT_1 input_91;
  SORT_1 input_105;
  SORT_1 input_111;
  SORT_1 input_117;
  SORT_1 input_123;
  SORT_1 input_124;
  SORT_1 input_125;
  SORT_70 input_141;
  // Collecting state declarations ...
  SORT_1 state_8 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_15 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_26 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_28 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_43 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_45 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_53 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_60 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_62 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_64 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_68 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_70 state_72 = __VERIFIER_nondet_ushort() & mask_SORT_70;
  // Initializing states ...
  SORT_1 init_9_arg_1 = var_7;
  state_8 = init_9_arg_1;
  SORT_1 init_16_arg_1 = var_7;
  state_15 = init_16_arg_1;
  SORT_1 init_27_arg_1 = var_7;
  state_26 = init_27_arg_1;
  SORT_1 init_29_arg_1 = var_7;
  state_28 = init_29_arg_1;
  SORT_1 init_44_arg_1 = var_7;
  state_43 = init_44_arg_1;
  SORT_1 init_46_arg_1 = var_7;
  state_45 = init_46_arg_1;
  SORT_1 init_54_arg_1 = var_22;
  state_53 = init_54_arg_1;
  SORT_1 init_61_arg_1 = var_7;
  state_60 = init_61_arg_1;
  SORT_1 init_63_arg_1 = var_7;
  state_62 = init_63_arg_1;
  SORT_1 init_65_arg_1 = var_7;
  state_64 = init_65_arg_1;
  SORT_1 init_69_arg_1 = var_7;
  state_68 = init_69_arg_1;
  SORT_70 init_73_arg_1 = var_71;
  state_72 = init_73_arg_1;
  for (;;) {
    // Getting external input values ...
    input_2 = __VERIFIER_nondet_uchar();
    input_4 = __VERIFIER_nondet_uchar();
    input_5 = __VERIFIER_nondet_uchar();
    input_6 = __VERIFIER_nondet_uchar();
    input_30 = __VERIFIER_nondet_uchar();
    input_33 = __VERIFIER_nondet_uchar();
    input_35 = __VERIFIER_nondet_uchar();
    input_37 = __VERIFIER_nondet_uchar();
    input_39 = __VERIFIER_nondet_uchar();
    input_41 = __VERIFIER_nondet_uchar();
    input_47 = __VERIFIER_nondet_uchar();
    input_49 = __VERIFIER_nondet_uchar();
    input_51 = __VERIFIER_nondet_uchar();
    input_55 = __VERIFIER_nondet_uchar();
    input_58 = __VERIFIER_nondet_uchar();
    input_66 = __VERIFIER_nondet_uchar();
    input_75 = __VERIFIER_nondet_uchar();
    input_77 = __VERIFIER_nondet_uchar();
    input_89 = __VERIFIER_nondet_uchar();
    input_90 = __VERIFIER_nondet_uchar();
    input_91 = __VERIFIER_nondet_uchar();
    input_105 = __VERIFIER_nondet_uchar();
    input_111 = __VERIFIER_nondet_uchar();
    input_117 = __VERIFIER_nondet_uchar();
    input_123 = __VERIFIER_nondet_uchar();
    input_124 = __VERIFIER_nondet_uchar();
    input_125 = __VERIFIER_nondet_uchar();
    input_141 = __VERIFIER_nondet_ushort();
    // Assuming invariants ...
    // Asserting properties ...
    SORT_1 var_11_arg_0 = state_8;
    var_11_arg_0 = var_11_arg_0 & mask_SORT_1;
    SORT_10 var_11 = var_11_arg_0;
    SORT_10 var_13_arg_0 = var_11;
    SORT_10 var_13_arg_1 = var_12;
    SORT_1 var_13 = var_13_arg_0 == var_13_arg_1;
    SORT_1 var_14_arg_0 = var_13;
    SORT_1 var_14 = ~var_14_arg_0;
    SORT_1 var_17_arg_0 = state_15;
    var_17_arg_0 = var_17_arg_0 & mask_SORT_1;
    SORT_10 var_17 = var_17_arg_0;
    SORT_10 var_18_arg_0 = var_17;
    SORT_10 var_18_arg_1 = var_12;
    SORT_1 var_18 = var_18_arg_0 == var_18_arg_1;
    SORT_1 var_19_arg_0 = var_14;
    SORT_1 var_19_arg_1 = var_18;
    SORT_1 var_19 = var_19_arg_0 | var_19_arg_1;
    SORT_1 var_23_arg_0 = var_19;
    SORT_1 var_23 = ~var_23_arg_0;
    SORT_1 var_24_arg_0 = var_22;
    SORT_1 var_24_arg_1 = var_23;
    SORT_1 var_24 = var_24_arg_0 & var_24_arg_1;
    var_24 = var_24 & mask_SORT_1;
    SORT_1 bad_25_arg_0 = var_24;
    __VERIFIER_assert(!(bad_25_arg_0));
    // Computing next states ...
    SORT_1 var_76_arg_0 = state_15;
    SORT_1 var_76_arg_1 = var_22;
    SORT_1 var_76_arg_2 = state_68;
    SORT_1 var_76 = var_76_arg_0 ? var_76_arg_1 : var_76_arg_2;
    SORT_1 var_78_arg_0 = var_76;
    SORT_1 var_78 = ~var_78_arg_0;
    var_78 = var_78 & mask_SORT_1;
    SORT_1 var_79_arg_0 = var_78;
    SORT_1 var_79_arg_1 = var_22;
    SORT_1 var_79_arg_2 = var_76;
    SORT_1 var_79 = var_79_arg_0 ? var_79_arg_1 : var_79_arg_2;
    SORT_1 var_80_arg_0 = state_45;
    SORT_1 var_80_arg_1 = var_79;
    SORT_1 var_80_arg_2 = input_77;
    SORT_1 var_80 = var_80_arg_0 ? var_80_arg_1 : var_80_arg_2;
    SORT_1 var_81_arg_0 = state_45;
    SORT_1 var_81_arg_1 = var_80;
    SORT_1 var_81_arg_2 = var_76;
    SORT_1 var_81 = var_81_arg_0 ? var_81_arg_1 : var_81_arg_2;
    SORT_1 var_82_arg_0 = var_81;
    SORT_1 var_82 = ~var_82_arg_0;
    SORT_1 var_83_arg_0 = input_5;
    SORT_1 var_83 = ~var_83_arg_0;
    SORT_1 var_84_arg_0 = var_82;
    SORT_1 var_84_arg_1 = var_83;
    SORT_1 var_84 = var_84_arg_0 | var_84_arg_1;
    var_84 = var_84 & mask_SORT_1;
    SORT_1 var_74_arg_0 = state_15;
    SORT_1 var_74_arg_1 = var_7;
    SORT_1 var_74_arg_2 = state_8;
    SORT_1 var_74 = var_74_arg_0 ? var_74_arg_1 : var_74_arg_2;
    SORT_1 var_85_arg_0 = var_84;
    SORT_1 var_85_arg_1 = var_74;
    SORT_1 var_85_arg_2 = var_22;
    SORT_1 var_85 = var_85_arg_0 ? var_85_arg_1 : var_85_arg_2;
    SORT_1 var_86_arg_0 = state_60;
    SORT_1 var_86_arg_1 = var_85;
    SORT_1 var_86_arg_2 = input_75;
    SORT_1 var_86 = var_86_arg_0 ? var_86_arg_1 : var_86_arg_2;
    SORT_1 var_87_arg_0 = state_60;
    SORT_1 var_87_arg_1 = var_86;
    SORT_1 var_87_arg_2 = var_74;
    SORT_1 var_87 = var_87_arg_0 ? var_87_arg_1 : var_87_arg_2;
    var_87 = var_87 & mask_SORT_1;
    SORT_1 next_88_arg_1 = var_87;
    SORT_70 var_94_arg_0 = state_72;
    var_94_arg_0 = var_94_arg_0 & mask_SORT_70;
    SORT_10 var_94 = var_94_arg_0;
    SORT_10 var_96_arg_0 = var_94;
    SORT_10 var_96_arg_1 = var_95;
    SORT_1 var_96 = var_96_arg_0 > var_96_arg_1;
    SORT_1 var_92_arg_0 = state_53;
    SORT_1 var_92_arg_1 = var_7;
    SORT_1 var_92 = var_92_arg_0 == var_92_arg_1;
    SORT_1 var_93_arg_0 = var_92;
    SORT_1 var_93_arg_1 = var_7;
    SORT_1 var_93_arg_2 = var_7;
    SORT_1 var_93 = var_93_arg_0 ? var_93_arg_1 : var_93_arg_2;
    SORT_1 var_97_arg_0 = var_96;
    SORT_1 var_97_arg_1 = var_93;
    SORT_1 var_97_arg_2 = input_91;
    SORT_1 var_97 = var_97_arg_0 ? var_97_arg_1 : var_97_arg_2;
    SORT_1 var_98_arg_0 = state_8;
    SORT_1 var_98_arg_1 = var_97;
    SORT_1 var_98_arg_2 = input_90;
    SORT_1 var_98 = var_98_arg_0 ? var_98_arg_1 : var_98_arg_2;
    SORT_1 var_99_arg_0 = var_96;
    SORT_1 var_99_arg_1 = var_98;
    SORT_1 var_99_arg_2 = var_7;
    SORT_1 var_99 = var_99_arg_0 ? var_99_arg_1 : var_99_arg_2;
    SORT_1 var_100_arg_0 = state_8;
    SORT_1 var_100_arg_1 = var_99;
    SORT_1 var_100_arg_2 = input_89;
    SORT_1 var_100 = var_100_arg_0 ? var_100_arg_1 : var_100_arg_2;
    SORT_1 var_101_arg_0 = state_8;
    SORT_1 var_101_arg_1 = var_100;
    SORT_1 var_101_arg_2 = var_7;
    SORT_1 var_101 = var_101_arg_0 ? var_101_arg_1 : var_101_arg_2;
    var_101 = var_101 & mask_SORT_1;
    SORT_1 next_102_arg_1 = var_101;
    SORT_1 var_103_arg_0 = state_26;
    SORT_1 var_103_arg_1 = var_7;
    SORT_1 var_103_arg_2 = var_22;
    SORT_1 var_103 = var_103_arg_0 ? var_103_arg_1 : var_103_arg_2;
    var_103 = var_103 & mask_SORT_1;
    SORT_1 next_104_arg_1 = var_103;
    SORT_1 var_107_arg_0 = state_28;
    SORT_1 var_107_arg_1 = var_7;
    SORT_1 var_107 = var_107_arg_0 == var_107_arg_1;
    SORT_1 var_106_arg_0 = state_62;
    SORT_1 var_106_arg_1 = var_22;
    SORT_1 var_106_arg_2 = var_7;
    SORT_1 var_106 = var_106_arg_0 ? var_106_arg_1 : var_106_arg_2;
    SORT_1 var_108_arg_0 = var_107;
    SORT_1 var_108_arg_1 = var_106;
    SORT_1 var_108_arg_2 = input_105;
    SORT_1 var_108 = var_108_arg_0 ? var_108_arg_1 : var_108_arg_2;
    SORT_1 var_109_arg_0 = state_28;
    SORT_1 var_109_arg_1 = var_7;
    SORT_1 var_109_arg_2 = var_108;
    SORT_1 var_109 = var_109_arg_0 ? var_109_arg_1 : var_109_arg_2;
    var_109 = var_109 & mask_SORT_1;
    SORT_1 next_110_arg_1 = var_109;
    SORT_1 var_113_arg_0 = state_43;
    SORT_1 var_113_arg_1 = var_7;
    SORT_1 var_113 = var_113_arg_0 == var_113_arg_1;
    SORT_1 var_112_arg_0 = state_64;
    SORT_1 var_112_arg_1 = var_22;
    SORT_1 var_112_arg_2 = var_7;
    SORT_1 var_112 = var_112_arg_0 ? var_112_arg_1 : var_112_arg_2;
    SORT_1 var_114_arg_0 = var_113;
    SORT_1 var_114_arg_1 = var_112;
    SORT_1 var_114_arg_2 = input_111;
    SORT_1 var_114 = var_114_arg_0 ? var_114_arg_1 : var_114_arg_2;
    SORT_1 var_115_arg_0 = state_43;
    SORT_1 var_115_arg_1 = var_7;
    SORT_1 var_115_arg_2 = var_114;
    SORT_1 var_115 = var_115_arg_0 ? var_115_arg_1 : var_115_arg_2;
    var_115 = var_115 & mask_SORT_1;
    SORT_1 next_116_arg_1 = var_115;
    SORT_1 var_119_arg_0 = state_43;
    SORT_1 var_119_arg_1 = var_7;
    SORT_1 var_119 = var_119_arg_0 == var_119_arg_1;
    SORT_1 var_118_arg_0 = state_64;
    SORT_1 var_118_arg_1 = var_22;
    SORT_1 var_118_arg_2 = state_45;
    SORT_1 var_118 = var_118_arg_0 ? var_118_arg_1 : var_118_arg_2;
    SORT_1 var_120_arg_0 = var_119;
    SORT_1 var_120_arg_1 = var_118;
    SORT_1 var_120_arg_2 = input_117;
    SORT_1 var_120 = var_120_arg_0 ? var_120_arg_1 : var_120_arg_2;
    SORT_1 var_121_arg_0 = state_43;
    SORT_1 var_121_arg_1 = var_7;
    SORT_1 var_121_arg_2 = var_120;
    SORT_1 var_121 = var_121_arg_0 ? var_121_arg_1 : var_121_arg_2;
    var_121 = var_121 & mask_SORT_1;
    SORT_1 next_122_arg_1 = var_121;
    SORT_1 var_126_arg_0 = state_53;
    SORT_1 var_126_arg_1 = var_7;
    SORT_1 var_126 = var_126_arg_0 == var_126_arg_1;
    SORT_1 var_127_arg_0 = var_126;
    SORT_1 var_127_arg_1 = var_22;
    SORT_1 var_127_arg_2 = var_22;
    SORT_1 var_127 = var_127_arg_0 ? var_127_arg_1 : var_127_arg_2;
    SORT_1 var_128_arg_0 = var_96;
    SORT_1 var_128_arg_1 = var_127;
    SORT_1 var_128_arg_2 = input_125;
    SORT_1 var_128 = var_128_arg_0 ? var_128_arg_1 : var_128_arg_2;
    SORT_1 var_129_arg_0 = state_8;
    SORT_1 var_129_arg_1 = var_128;
    SORT_1 var_129_arg_2 = input_124;
    SORT_1 var_129 = var_129_arg_0 ? var_129_arg_1 : var_129_arg_2;
    SORT_1 var_130_arg_0 = var_96;
    SORT_1 var_130_arg_1 = var_129;
    SORT_1 var_130_arg_2 = state_53;
    SORT_1 var_130 = var_130_arg_0 ? var_130_arg_1 : var_130_arg_2;
    SORT_1 var_131_arg_0 = state_8;
    SORT_1 var_131_arg_1 = var_130;
    SORT_1 var_131_arg_2 = input_123;
    SORT_1 var_131 = var_131_arg_0 ? var_131_arg_1 : var_131_arg_2;
    SORT_1 var_132_arg_0 = state_8;
    SORT_1 var_132_arg_1 = var_131;
    SORT_1 var_132_arg_2 = state_53;
    SORT_1 var_132 = var_132_arg_0 ? var_132_arg_1 : var_132_arg_2;
    var_132 = var_132 & mask_SORT_1;
    SORT_1 next_133_arg_1 = var_132;
    SORT_1 var_134_arg_0 = state_43;
    SORT_1 var_134_arg_1 = var_22;
    SORT_1 var_134_arg_2 = state_60;
    SORT_1 var_134 = var_134_arg_0 ? var_134_arg_1 : var_134_arg_2;
    var_134 = var_134 & mask_SORT_1;
    SORT_1 next_135_arg_1 = var_134;
    SORT_1 var_136_arg_0 = state_26;
    SORT_1 var_136_arg_1 = state_62;
    SORT_1 var_136_arg_2 = state_62;
    SORT_1 var_136 = var_136_arg_0 ? var_136_arg_1 : var_136_arg_2;
    var_136 = var_136 & mask_SORT_1;
    SORT_1 next_137_arg_1 = var_136;
    SORT_1 var_138_arg_0 = state_28;
    SORT_1 var_138_arg_1 = var_22;
    SORT_1 var_138_arg_2 = state_64;
    SORT_1 var_138 = var_138_arg_0 ? var_138_arg_1 : var_138_arg_2;
    var_138 = var_138 & mask_SORT_1;
    SORT_1 next_139_arg_1 = var_138;
    SORT_1 next_140_arg_1 = var_81;
    SORT_70 var_142_arg_0 = state_72;
    var_142_arg_0 = var_142_arg_0 & mask_SORT_70;
    SORT_10 var_142 = var_142_arg_0;
    SORT_10 var_144_arg_0 = var_142;
    SORT_10 var_144_arg_1 = var_143;
    SORT_10 var_144 = var_144_arg_0 + var_144_arg_1;
    SORT_10 var_145_arg_0 = var_144;
    SORT_70 var_145 = var_145_arg_0 >> 0;
    SORT_1 var_146_arg_0 = var_96;
    SORT_70 var_146_arg_1 = var_71;
    SORT_70 var_146_arg_2 = var_145;
    SORT_70 var_146 = var_146_arg_0 ? var_146_arg_1 : var_146_arg_2;
    SORT_1 var_147_arg_0 = state_8;
    SORT_70 var_147_arg_1 = var_146;
    SORT_70 var_147_arg_2 = input_141;
    SORT_70 var_147 = var_147_arg_0 ? var_147_arg_1 : var_147_arg_2;
    SORT_1 var_148_arg_0 = state_8;
    SORT_70 var_148_arg_1 = var_147;
    SORT_70 var_148_arg_2 = state_72;
    SORT_70 var_148 = var_148_arg_0 ? var_148_arg_1 : var_148_arg_2;
    SORT_70 next_149_arg_1 = var_148;
    // Assigning next states ...
    state_8 = next_88_arg_1;
    state_15 = next_102_arg_1;
    state_26 = next_104_arg_1;
    state_28 = next_110_arg_1;
    state_43 = next_116_arg_1;
    state_45 = next_122_arg_1;
    state_53 = next_133_arg_1;
    state_60 = next_135_arg_1;
    state_62 = next_137_arg_1;
    state_64 = next_139_arg_1;
    state_68 = next_140_arg_1;
    state_72 = next_149_arg_1;
  }
  return 0;
}
